using LLVM
using LLVM.Interop

const MEMORY_ORDERING_EXPLANATION = """
specified as a symbol (e.g., `:sequentially_consistent`) or a `Val` of a symbol (e.g.,
`Val(:sequentially_consistent)`)
"""

"""
    atomic_pointerref(pointer::LLVMPtr{T}, ordering) -> value::T
Load a `value` from `pointer` with the given memory `ordering` atomically.
`ordering` is a Julia atomic ordering $MEMORY_ORDERING_EXPLANATION.
See also: `getproperty`, `getfield`
"""
atomic_pointerref

"""
    LLVM.Interop.atomic_pointerset(pointer::LLVMPtr{T}, x::T, ordering) -> pointer
Store a value `x` in `pointer` with the given memory `ordering` atomically.
`ordering` is a Julia atomic ordering $MEMORY_ORDERING_EXPLANATION.
See also: `setproperty!`, `setfield!`
"""
atomic_pointerset

"""
    atomic_pointermodify(
        pointer::LLVMPtr{T},
        op,
        x::T,
        ordering,
    ) -> (old => new)::Pair{T,T}
Replace an `old` value stored at `pointer` with a `new` value comped as `new = op(old, x)`
with the given memory `ordering` atomically.  Return a pair `old => new`.
`ordering` is a Julia atomic ordering $MEMORY_ORDERING_EXPLANATION.
See also: `modifyproperty!`, `modifyfield!`
"""
atomic_pointermodify

"""
    atomic_pointerswap(pointer::LLVMPtr{T}, op, new::T, ordering) -> old::T
Replace an `old` value stored at `pointer` with a `new` value with the given memory
`ordering` atomically.  Return the `old` value.
`ordering` is a Julia atomic ordering $MEMORY_ORDERING_EXPLANATION.
See also: `modifyproperty!`, `modifyfield!`
"""
atomic_pointerswap

"""
    atomic_pointerreplace(
        pointer::LLVMPtr{T},
        expected::T,
        desired::T,
        success_ordering,
        fail_ordering,
    ) -> (; old::T, success::Bool)
Try to replace the value of `pointer` from an `expected` value to a `desired` value
atomically with the ordering `success_ordering`.  The property `old` of the returned value
is the value stored in the `pointer`.  The property `success` of the returned value
indicates if the replacement was successful.  The ordering `fail_ordering` specifies the
ordering used for loading the `old` value.
`success_ordering` and `fail_ordering` are Julia atomic orderings
$MEMORY_ORDERING_EXPLANATION.
See also: `replaceproperty!`, `replacefield!`
"""
atomic_pointerreplace

const _llvm_from_julia_ordering = (
    not_atomic = LLVM.API.LLVMAtomicOrderingNotAtomic,
    unordered = LLVM.API.LLVMAtomicOrderingUnordered,
    monotonic = LLVM.API.LLVMAtomicOrderingMonotonic,
    acquire = LLVM.API.LLVMAtomicOrderingAcquire,
    release = LLVM.API.LLVMAtomicOrderingRelease,
    acquire_release = LLVM.API.LLVMAtomicOrderingAcquireRelease,
    sequentially_consistent = LLVM.API.LLVMAtomicOrderingSequentiallyConsistent,
)

_julia_ordering(p) =
    Union{map(x -> p(x) ? Val{x} : Union{}, keys(_llvm_from_julia_ordering))...}

const AllOrdering = _julia_ordering(_ -> true)
const AtomicOrdering = _julia_ordering(!=(:not_atomic))

const LLVMOrderingVal = Union{map(x -> Val{x}, values(_llvm_from_julia_ordering))...}

is_stronger_than_monotonic(order::Symbol) =
    !(order === :monotonic || order === :unordered || order === :not_atomic)

for (julia, llvm) in pairs(_llvm_from_julia_ordering)
    @eval llvm_from_julia_ordering(::Val{$(QuoteNode(julia))}) = Val{$llvm}()
end

_valueof(::Val{x}) where {x} = x

@generated function atomic_pointerref(ptr::LLVMPtr{T,A}, order::AllOrdering, sync) where {T,A}
    sizeof(T) == 0 && return T.instance
    llvm_order     = _valueof(llvm_from_julia_ordering(order()))
    llvm_syncscope = _valueof(sync())
    @dispose ctx = Context() begin
        eltyp = convert(LLVMType, T)

        T_ptr = convert(LLVMType, ptr)

        T_typed_ptr = LLVM.PointerType(eltyp, A)

        # create a function
        param_types = [T_ptr]
        llvm_f, _ = create_function(eltyp, param_types)

        # generate IR
        @dispose builder = IRBuilder() begin
            entry = BasicBlock(llvm_f, "entry")
            position!(builder, entry)

            typed_ptr = bitcast!(builder, parameters(llvm_f)[1], T_typed_ptr)
            ld = load!(builder, eltyp, typed_ptr)
            ordering!(ld, llvm_order)
            syncscope!(ld, SyncScope(string(llvm_syncscope)))

            if A != 0
                metadata(ld)[LLVM.MD_tbaa] = tbaa_addrspace(A)
            end
            alignment!(ld, sizeof(T))

            ret!(builder, ld)
        end

        call_function(llvm_f, T, Tuple{LLVMPtr{T,A}}, :ptr)
    end
end

@generated function atomic_pointerset(
    ptr::LLVMPtr{T,A},
    x::T,
    order::AllOrdering,
    sync,
) where {T,A}
    if sizeof(T) == 0
        # Mimicking what `Core.Intrinsics.atomic_pointerset` generates.
        # See: https://github.com/JuliaLang/julia/blob/v1.7.2/src/cgutils.cpp#L1570-L1572
        if VERSION < v"1.14.0-DEV.1371"
            return quote
                is_stronger_than_monotonic(_valueof(order)) || return ptr
                Core.Intrinsics.atomic_fence(_valueof(order))
                return ptr
            end
        else
            return quote
                is_stronger_than_monotonic(_valueof(order)) || return ptr
                Core.Intrinsics.atomic_fence(_valueof(order), :system)
                return ptr
            end
        end
    end
    llvm_order     = _valueof(llvm_from_julia_ordering(order()))
    llvm_syncscope = _valueof(sync())
    @dispose ctx = Context() begin
        eltyp = convert(LLVMType, T)
        T_ptr = convert(LLVMType, ptr)
        T_typed_ptr = LLVM.PointerType(eltyp, A)

        # create a function
        param_types = [T_ptr, eltyp]
        llvm_f, _ = create_function(LLVM.VoidType(), param_types)

        # generate IR
        @dispose builder = IRBuilder() begin
            entry = BasicBlock(llvm_f, "entry")
            position!(builder, entry)

            typed_ptr = bitcast!(builder, parameters(llvm_f)[1], T_typed_ptr)
            val = parameters(llvm_f)[2]
            st = store!(builder, val, typed_ptr)
            ordering!(st, llvm_order)
            syncscope!(st, SyncScope(string(llvm_syncscope)))

            if A != 0
                metadata(st)[LLVM.MD_tbaa] = tbaa_addrspace(A)
            end
            alignment!(st, sizeof(T))

            ret!(builder)
        end

        call = call_function(llvm_f, Cvoid, Tuple{LLVMPtr{T,A},T}, :ptr, :x)
        quote
            $call
            ptr
        end
    end
end

right(_, r) = r

const binoptable = [
    (:xchg, right, LLVM.API.LLVMAtomicRMWBinOpXchg),
    (:add, +, LLVM.API.LLVMAtomicRMWBinOpAdd),
    (:sub, -, LLVM.API.LLVMAtomicRMWBinOpSub),
    (:and, &, LLVM.API.LLVMAtomicRMWBinOpAnd),
    (:or, |, LLVM.API.LLVMAtomicRMWBinOpOr),
    (:xor, xor, LLVM.API.LLVMAtomicRMWBinOpXor),
    (:max, max, LLVM.API.LLVMAtomicRMWBinOpMax),
    (:min, min, LLVM.API.LLVMAtomicRMWBinOpMin),
    (:umax, max, LLVM.API.LLVMAtomicRMWBinOpUMax),
    (:umin, min, LLVM.API.LLVMAtomicRMWBinOpUMin),
    (:fadd, +, LLVM.API.LLVMAtomicRMWBinOpFAdd),
    (:fsub, -, LLVM.API.LLVMAtomicRMWBinOpFSub),
    (:fmax, max, LLVM.API.LLVMAtomicRMWBinOpFMax),
    (:fmin, min, LLVM.API.LLVMAtomicRMWBinOpFMin),
]

const AtomicRMWBinOpVal = Union{(Val{binop} for (_, _, binop) in binoptable)...}

@generated function llvm_atomic_op(
    binop::AtomicRMWBinOpVal,
    ptr::LLVMPtr{T,A},
    val::T,
    order::LLVMOrderingVal,
    sync,
) where {T,A}
    @dispose ctx = Context() begin
        T_val = convert(LLVMType, T)
        T_ptr = convert(LLVMType, ptr)

        T_typed_ptr = LLVM.PointerType(T_val, A)

        llvm_f, _ = create_function(T_val, [T_ptr, T_val])
        llvm_syncscope = _valueof(sync())

        @dispose builder = IRBuilder() begin
            entry = BasicBlock(llvm_f, "entry")
            position!(builder, entry)

            typed_ptr = bitcast!(builder, parameters(llvm_f)[1], T_typed_ptr)

            rv = atomic_rmw!(
                builder,
                _valueof(binop()),
                typed_ptr,
                parameters(llvm_f)[2],
                _valueof(order()),
                SyncScope(string(llvm_syncscope))
            )

            ret!(builder, rv)
        end

        call_function(llvm_f, T, Tuple{LLVMPtr{T,A},T}, :ptr, :val)
    end
end

@inline function atomic_pointermodify(
    ptr::LLVMPtr{T},
    ::typeof(right),
    x::T,
    order::AtomicOrdering,
    sync::Val{S}
) where {T, S}
    old = llvm_atomic_op(
        Val(LLVM.API.LLVMAtomicRMWBinOpXchg),
        ptr,
        x,
        llvm_from_julia_ordering(order),
        sync
    )
    return old => x
end

const atomictypes = Any[
    Int8,
    Int16,
    Int32,
    Int64,
    Int128,
    UInt8,
    UInt16,
    UInt32,
    UInt64,
    UInt128,
    Float16,
    Float32,
    Float64,
]

for (opname, op, llvmop) in binoptable
    opname === :xchg && continue
    types = if opname in (:min, :max)
        filter(t -> t <: Signed, atomictypes)
    elseif opname in (:umin, :umax)
        filter(t -> t <: Unsigned, atomictypes)
    elseif opname in (:fadd, :fsub, :fmin, :fmax)
        filter(t -> t <: AbstractFloat, atomictypes)
    else
        filter(t -> t <: Integer, atomictypes)
    end
    for T in types
        @eval @inline function atomic_pointermodify(
            ptr::LLVMPtr{$T},
            ::$(typeof(op)),
            x::$T,
            order::AtomicOrdering,
            sync::Val{S},
        ) where {S}
            old = llvm_atomic_op(
                $(Val(llvmop)), ptr, x, llvm_from_julia_ordering(order), sync)
            return old => $op(old, x)
        end
    end
end

# @inline atomic_pointerswap(pointer, new) = first(atomic_pointermodify(pointer, right, new))
@inline atomic_pointerswap(pointer, new, order, sync) =
    first(atomic_pointermodify(pointer, right, new, order, sync))

@inline function atomic_pointermodify(
    ptr::LLVMPtr{T},
    op,
    x::T,
    order::AllOrdering,
    sync::S,
) where {T, S}
    # Should `fail_order` be stronger?  Ref: https://github.com/JuliaLang/julia/issues/45256
    fail_order = Val(:monotonic)
    old = atomic_pointerref(ptr, fail_order, sync)
    while true
        new = op(old, x)
        (old, success) = atomic_pointerreplace(ptr, old, new, order, fail_order, sync)
        success && return old => new
    end
end

@generated function llvm_atomic_cas(
    ptr::LLVMPtr{T,A},
    cmp::T,
    val::T,
    success_order::LLVMOrderingVal,
    fail_order::LLVMOrderingVal,
    sync,
) where {T,A}
    llvm_success = _valueof(success_order())
    llvm_fail = _valueof(fail_order())
    llvm_syncscope = _valueof(sync())
    @dispose ctx = Context() begin
        T_val = convert(LLVMType, T)
        T_pointee = T_val
        if T_val isa LLVM.FloatingPointType
            T_pointee = LLVM.IntType(sizeof(T) * 8)
        end
        T_ptr = convert(LLVMType, ptr)
        T_success = convert(LLVMType, Ptr{Int8})

        T_typed_ptr = LLVM.PointerType(T_pointee, A)
        T_ok_ptr = LLVM.PointerType(convert(LLVMType, Int8))

        llvm_f, _ = create_function(T_val, [T_ptr, T_val, T_val, T_success])

        @dispose builder = IRBuilder() begin
            entry = BasicBlock(llvm_f, "entry")
            position!(builder, entry)

            typed_ptr = bitcast!(builder, parameters(llvm_f)[1], T_typed_ptr)
            ok_ptr = inttoptr!(builder, parameters(llvm_f)[4], T_ok_ptr)

            cmp_int = parameters(llvm_f)[2]
            if T_val isa LLVM.FloatingPointType
                cmp_int = bitcast!(builder, cmp_int, T_pointee)
            end

            val_int = parameters(llvm_f)[3]
            if T_val isa LLVM.FloatingPointType
                val_int = bitcast!(builder, val_int, T_pointee)
            end

            res = atomic_cmpxchg!(
                builder,
                typed_ptr,
                cmp_int,
                val_int,
                llvm_success,
                llvm_fail,
                SyncScope(string(llvm_syncscope)),
            )

            rv = extract_value!(builder, res, 0)
            ok = extract_value!(builder, res, 1)
            ok = zext!(builder, ok, LLVM.Int8Type())
            store!(builder, ok, ok_ptr)

            if T_val isa LLVM.FloatingPointType
                rv = bitcast!(builder, rv, T_val)
            end

            ret!(builder, rv)
        end

        expr = call_function(
            llvm_f,
            T,
            Tuple{LLVMPtr{T,A},T,T,Ptr{Int8}},
            :ptr,
            :cmp,
            :val,
            :success_ptr,
        )
        quote
            success = Ref{Int8}()
            old = GC.@preserve success begin
                success_ptr = Ptr{Int8}(pointer_from_objref(success))
                $expr
            end
            (; old, success = success[] != zero(Int8))
        end
    end
end

@inline function atomic_pointerreplace(
    ptr::LLVMPtr{T},
    expected::T,
    desired::T,
    ::Val{:not_atomic},
    ::Val{:not_atomic},
    sync,
) where {T}
    old = atomic_pointerref(ptr, Val(:not_atomic), sync)
    if old === expected
        atomic_pointerset(ptr, desired, Val(:not_atomic), sync)
        success = true
    else
        success = false
    end
    return (; old, success)
end

@inline atomic_pointerreplace(
    ptr::LLVMPtr{T},
    expected::T,
    desired::T,
    success_order::_julia_ordering(∉((:not_atomic, :unordered))),
    fail_order::_julia_ordering(∉((:not_atomic, :unordered, :release, :acquire_release))),
    sync
) where {T} = llvm_atomic_cas(
    ptr,
    expected,
    desired,
    llvm_from_julia_ordering(success_order),
    llvm_from_julia_ordering(fail_order),
    sync
)

struct LLVMOrdering{name} <: Ordering end

const unordered = LLVMOrdering{:unordered}()
const monotonic = LLVMOrdering{:monotonic}()
const acquire = LLVMOrdering{:acquire}()
const release = LLVMOrdering{:release}()
const acq_rel = LLVMOrdering{:acq_rel}()
const seq_cst = LLVMOrdering{:seq_cst}()

const orderings = (unordered, monotonic, acquire, release, acq_rel, seq_cst)

const ConcreteOrdering = Union{map(typeof, orderings)...}

llvm_ordering(::LLVMOrdering{name}) where {name} = name

Base.string(o::LLVMOrdering) = String(llvm_ordering(o))
Base.print(io::IO, o::LLVMOrdering) = print(io, string(o))

Base.show(io::IO, o::ConcreteOrdering) = print(io, UnsafeAtomics, '.', llvm_ordering(o))

base_ordering(::LLVMOrdering{name}) where {name} = name
base_ordering(::LLVMOrdering{:seq_cst}) = :sequentially_consistent
base_ordering(::LLVMOrdering{:acq_rel}) = :acquire_release

@inline UnsafeAtomics.load(x) = UnsafeAtomics.load(x, seq_cst)
@inline UnsafeAtomics.store!(x, v) = UnsafeAtomics.store!(x, v, seq_cst)
@inline UnsafeAtomics.cas!(x, cmp, new) = UnsafeAtomics.cas!(x, cmp, new, seq_cst, seq_cst)
@inline UnsafeAtomics.modify!(ptr, op, x) = UnsafeAtomics.modify!(ptr, op, x, seq_cst)
@inline UnsafeAtomics.fence() = UnsafeAtomics.fence(seq_cst)

@inline UnsafeAtomics.load(x, ord) = UnsafeAtomics.load(x, ord, none)
@inline UnsafeAtomics.store!(x, v, ord) = UnsafeAtomics.store!(x, v, ord, none)
@inline UnsafeAtomics.cas!(x, cmp, new, ord) = UnsafeAtomics.cas!(x, cmp, new, ord, ord, none)
@inline UnsafeAtomics.cas!(x, cmp, new, success_ord, failure_order) = UnsafeAtomics.cas!(x, cmp, new, success_ord, failure_order, none)
@inline UnsafeAtomics.modify!(ptr, op, x, ord) = UnsafeAtomics.modify!(ptr, op, x, ord, none)
@inline UnsafeAtomics.fence(ord) = UnsafeAtomics.fence(ord, none)

#! format: off
# https://github.com/JuliaLang/julia/blob/v1.6.3/base/atomics.jl#L23-L30
if Sys.ARCH == :i686 || startswith(string(Sys.ARCH), "arm") ||
   Sys.ARCH === :powerpc64le || Sys.ARCH === :ppc64le
    const inttypes = (Int8, Int16, Int32, Int64,
                      UInt8, UInt16, UInt32, UInt64)
else
    const inttypes = (Int8, Int16, Int32, Int64, Int128,
                      UInt8, UInt16, UInt32, UInt64, UInt128)
end
const floattypes = (Float16, Float32, Float64)

# https://github.com/JuliaLang/julia/blob/v1.6.3/base/atomics.jl#L331-L341
const llvmtypes = IdDict{Any,String}(
    Bool => "i8",  # julia represents bools with 8-bits for now. # TODO: is this okay?
    Int8 => "i8", UInt8 => "i8",
    Int16 => "i16", UInt16 => "i16",
    Int32 => "i32", UInt32 => "i32",
    Int64 => "i64", UInt64 => "i64",
    Int128 => "i128", UInt128 => "i128",
    Float16 => "half",
    Float32 => "float",
    Float64 => "double",
)
#! format: on

const OP_RMW_TABLE = [
    (+) => :add,
    (-) => :sub,
    right => :xchg,
    (&) => :and,
    (⊼) => :nand,
    (|) => :or,
    (⊻) => xor,
    max => :max,
    min => :min,
]

for (op, rmwop) in OP_RMW_TABLE
    fn = Symbol(rmwop, "!")
    @eval @inline UnsafeAtomics.$fn(x, v) = UnsafeAtomics.$fn(x, v, seq_cst)
    @eval @inline UnsafeAtomics.$fn(x, v, ord) = UnsafeAtomics.$fn(x, v, ord, none) 
    @eval @inline UnsafeAtomics.$fn(ptr, x, ord, scope) =
        first(UnsafeAtomics.modify!(ptr, $op, x, ord, scope))
end

const ATOMIC_INTRINSICS = isdefined(Core.Intrinsics, :atomic_pointerref)

if VERSION >= v"1.12.0-DEV.161" && Int == Int64
const MAX_ATOMIC_SIZE = 16
const MAX_POINTERATOMIC_SIZE = 16
else
const MAX_ATOMIC_SIZE = 8
const MAX_POINTERATOMIC_SIZE = 8
end


if VERSION < v"1.12.0"
    ptr(typ) = typ*"*"
    inttoptr(typ, arg) = "inttoptr i$WORD_SIZE $arg to $(ptr(typ))"
else
    ptr(typ) = "ptr"
    inttoptr(_, arg) = "bitcast ptr $arg to ptr"
end

# Based on: https://github.com/JuliaLang/julia/blob/v1.6.3/base/atomics.jl
for typ in (inttypes..., floattypes...)
    lt = llvmtypes[typ]
    rt = "$lt, $(ptr(lt))"

    for ord in orderings
        ord in (release, acq_rel) && continue

        for sync in syncscopes 
            if ATOMIC_INTRINSICS && sizeof(typ) <= MAX_POINTERATOMIC_SIZE && sync == none
                @eval function UnsafeAtomics.load(x::Ptr{$typ}, ::$(typeof(ord)), ::$(typeof(sync)))
                    return Core.Intrinsics.atomic_pointerref(x, base_ordering($ord))
                end
            else
                @eval function UnsafeAtomics.load(x::Ptr{$typ}, ::$(typeof(ord)), ::$(typeof(sync)))
                    return llvmcall(
                        $("""
                        %ptr = $(inttoptr(lt, "%0"))
                        %rv = load atomic $rt %ptr $ord, align $(sizeof(typ))
                        ret $lt %rv
                        """),
                        $typ,
                        Tuple{Ptr{$typ}},
                        x,
                    )
                end
            end
        end
    end

    for ord in orderings
        ord in (acquire, acq_rel) && continue
        
        for sync in syncscopes 
            if ATOMIC_INTRINSICS && sizeof(typ) <= MAX_POINTERATOMIC_SIZE && sync == none
                @eval function UnsafeAtomics.store!(x::Ptr{$typ}, v::$typ, ::$(typeof(ord)), ::$(typeof(sync)))
                    Core.Intrinsics.atomic_pointerset(x, v, base_ordering($ord))
                    return nothing
                end
            else
                @eval function UnsafeAtomics.store!(x::Ptr{$typ}, v::$typ, ::$(typeof(ord)), ::$(typeof(sync)))
                    return llvmcall(
                        $("""
                        %ptr = $(inttoptr(lt, "%0"))
                        store atomic $lt %1, $(ptr(lt)) %ptr $ord, align $(sizeof(typ))
                        ret void
                        """),
                        Cvoid,
                        Tuple{Ptr{$typ},$typ},
                        x,
                        v,
                    )
                end
            end
        end
    end

    for success_ordering in (monotonic, acquire, release, acq_rel, seq_cst),
        failure_ordering in (monotonic, acquire, seq_cst)

        typ <: AbstractFloat && break

        for sync in syncscopes 
            if ATOMIC_INTRINSICS && sizeof(typ) <= MAX_POINTERATOMIC_SIZE && sync == none
                @eval function UnsafeAtomics.cas!(
                    x::Ptr{$typ},
                    cmp::$typ,
                    new::$typ,
                    ::$(typeof(success_ordering)),
                    ::$(typeof(failure_ordering)),
                    ::$(typeof(sync)),
                )
                    return Core.Intrinsics.atomic_pointerreplace(
                        x,
                        cmp,
                        new,
                        base_ordering($success_ordering),
                        base_ordering($failure_ordering)
                    )
                end
            else
                @eval function UnsafeAtomics.cas!(
                    x::Ptr{$typ},
                    cmp::$typ,
                    new::$typ,
                    ::$(typeof(success_ordering)),
                    ::$(typeof(failure_ordering)),
                    ::$(typeof(sync)),
                )
                    success = Ref{Int8}()
                    GC.@preserve success begin
                        old = llvmcall(
                            $(
                                """
                                %ptr = $(inttoptr(lt, "%0"))
                                %rs = cmpxchg $(ptr(lt)) %ptr, $lt %1, $lt %2 $success_ordering $failure_ordering
                                %rv = extractvalue { $lt, i1 } %rs, 0
                                %s1 = extractvalue { $lt, i1 } %rs, 1
                                %s8 = zext i1 %s1 to i8
                                %sptr = $(inttoptr("i8", "%3"))
                                store i8 %s8, $(ptr("i8")) %sptr
                                ret $lt %rv
                                """
                            ),
                            $typ,
                            Tuple{Ptr{$typ},$typ,$typ,Ptr{Int8}},
                            x,
                            cmp,
                            new,
                            Ptr{Int8}(pointer_from_objref(success)),
                        )
                    end
                    return (old = old, success = !iszero(success[]))
                end
            end
        end
    end

    for (op, rmwop) in OP_RMW_TABLE
        rmw = string(rmwop)
        fn = Symbol(rmw, "!")
        if (rmw == "max" || rmw == "min") && typ <: Unsigned
            # LLVM distinguishes signedness in the operation, not the integer type.
            rmw = "u" * rmw
        end
        if typ <: AbstractFloat
            if rmw == "add"
                rmw = "fadd"
            elseif rmw == "sub"
                rmw = "fsub"
            else
                continue
            end
        end
        for ord in orderings
            for sync in syncscopes
                # Enable this code iff https://github.com/JuliaLang/julia/pull/45122 get's merged
                if false && ATOMIC_INTRINSICS && sizeof(typ) <= MAX_POINTERATOMIC_SIZE && sync == none
                    @eval function UnsafeAtomics.modify!(
                            x::Ptr{$typ},
                            op::typeof($op),
                            v::$typ,
                            ::$(typeof(ord)),
                            ::$(typeof(sync)),
                        )
                            return Core.Intrinsics.atomic_pointermodify(x, op, v, base_ordering($ord))
                    end
                else
                    @eval function UnsafeAtomics.modify!(
                        x::Ptr{$typ},
                        ::typeof($op),
                        v::$typ,
                        ::$(typeof(ord)),
                        ::$(typeof(sync)),
                    )
                        old = llvmcall(
                            $("""
                            %ptr = $(inttoptr(lt, "%0"))
                            %rv = atomicrmw $rmw $(ptr(lt)) %ptr, $lt %1 $ord
                            ret $lt %rv
                            """),
                            $typ,
                            Tuple{Ptr{$typ},$typ},
                            x,
                            v,
                        )
                        return old => $op(old, v)
                    end
                end
            end
        end
    end
end

for sync in syncscopes
    if sync == none
        # Core.Intrinsics.atomic_fence was introduced in 1.10
        if VERSION < v"1.14.0-DEV.1371"
            @eval function UnsafeAtomics.fence(ord::Ordering, ::$(typeof(sync)))
                Core.Intrinsics.atomic_fence(base_ordering(ord))
                return nothing
            end
        else
            @eval function UnsafeAtomics.fence(ord::Ordering, ::$(typeof(sync)))
                Core.Intrinsics.atomic_fence(base_ordering(ord), :system)
                return nothing
            end
        end
        if Sys.ARCH == :x86_64
            # FIXME: Disable this once on LLVM 19
            # This is unfortunatly required for good-performance on AMD
            # https://github.com/llvm/llvm-project/pull/106555
            @eval function UnsafeAtomics.fence(::typeof(seq_cst), ::$(typeof(sync)))
                Base.llvmcall(
                    (raw"""
                    define void @fence() #0 {
                    entry:
                        tail call void asm sideeffect "lock orq $$0 , (%rsp)", ""(); should this have ~{memory}
                        ret void
                    }
                    attributes #0 = { alwaysinline }
                    """, "fence"), Nothing, Tuple{})
            end
        end
    else
        for ord in orderings
            @eval function UnsafeAtomics.fence(::$(typeof(ord)), ::$(typeof(sync)))
                return llvmcall(
                    $("""
                    fence $sync $ord
                    ret void
                    """),
                    Cvoid,
                    Tuple{},
                )
            end
        end
    end
end

as_native_uint(::Type{T}) where {T} =
    if sizeof(T) == 1
        UInt8
    elseif sizeof(T) == 2
        UInt16
    elseif sizeof(T) == 4
        UInt32
    elseif sizeof(T) == 8
        UInt64
    elseif sizeof(T) == 16
        UInt128
    else
        error(LazyString("unsupported size: ", sizeof(T)))
    end

function UnsafeAtomics.load(x::Ptr{T}, ordering, syncscope) where {T}
    UI = as_native_uint(T)
    v = UnsafeAtomics.load(Ptr{UI}(x), ordering, syncscope)
    return bitcast(T, v)
end

function UnsafeAtomics.store!(x::Ptr{T}, v::T, ordering, syncscope) where {T}
    UI = as_native_uint(T)
    UnsafeAtomics.store!(Ptr{UI}(x), bitcast(UI, v), ordering, syncscope)::Nothing
end

function UnsafeAtomics.modify!(x::Ptr{T}, ::typeof(right), v::T, ordering, syncscope) where {T}
    UI = as_native_uint(T)
    old, _ = UnsafeAtomics.modify!(Ptr{UI}(x), right, bitcast(UI, v), ordering, syncscope)
    return bitcast(T, old) => v
end

function UnsafeAtomics.cas!(
    x::Ptr{T},
    cmp::T,
    new::T,
    success_ordering,
    failure_ordering,
    syncscope,
) where {T}
    UI = as_native_uint(T)
    (old, success) = UnsafeAtomics.cas!(
        Ptr{UI}(x),
        bitcast(UI, cmp),
        bitcast(UI, new),
        success_ordering,
        failure_ordering,
        syncscope
    )
    return (old = bitcast(T, old), success = success)
end

import LLVM
import InteractiveUtils

using UnsafeAtomics: UnsafeAtomics, acquire, release, acq_rel, seq_cst
using UnsafeAtomics.Internal: OP_RMW_TABLE, inttypes
using Test

llvmptr(xs::Array, i) = reinterpret(Core.LLVMPtr{eltype(xs),0}, pointer(xs, i))

function check_default_ordering(T::Type)
    xs = T[rand(T), rand(T)]
    x1 = rand(T)
    x2 = rand(T)
    check_default_ordering(xs, x1, x2)
end

function check_default_ordering(xs::AbstractArray{T}, x1::T, x2::T) where T
    @debug "xs=$(repr(xs)) x1=$(repr(x1)) x2=$(repr(x2))"

    ptr = llvmptr(xs, 1)
    GC.@preserve xs begin
        @test UnsafeAtomics.load(ptr) === xs[1]
        UnsafeAtomics.store!(ptr, x1)
        @test xs[1] === x1
        sizeof(T) == 0 && return # CAS hangs on zero sized data...
        desired = (old = x1, success = true)
        @test UnsafeAtomics.cas!(ptr, x1, x2) === (old = x1, success = true)
        @test xs[1] === x2
        @testset for (op, name) in OP_RMW_TABLE
            xs[1] = x1
            @test UnsafeAtomics.modify!(ptr, op, x2) === (x1 => op(x1, x2))
            @test xs[1] === op(x1, x2)

            rmw = getfield(UnsafeAtomics, Symbol(name, :!))
            xs[1] = x1
            @test rmw(ptr, x2) === x1
            @test xs[1] === op(x1, x2)

            # Check dispatch to LLVM atomic OP instead of CAS loop.
            if (op == +) || (op == -)
                IR = sprint(io->InteractiveUtils.code_llvm(io,
                    UnsafeAtomics.modify!,
                    typeof.((ptr, +, T(1)))))
                @test occursin("atomicrmw", IR)
            end
        end
    end
end

function test_explicit_ordering(T::Type = UInt)
    xs = T[rand(T), rand(T)]
    x1 = rand(T)
    x2 = rand(T)
    test_explicit_ordering(xs, x1, x2)
end

function test_explicit_ordering(xs::AbstractArray{T}, x1::T, x2::T) where T
    @debug "xs=$(repr(xs)) x1=$(repr(x1)) x2=$(repr(x2))"

    ptr = llvmptr(xs, 1)
    GC.@preserve xs begin

        @test UnsafeAtomics.load(ptr, acquire) === xs[1]
        UnsafeAtomics.store!(ptr, x1, release)
        @test xs[1] === x1
        sizeof(T) == 0 && return # CAS hangs on zero sized data...
        desired = (old = x1, success = true)
        @test UnsafeAtomics.cas!(ptr, x1, x2, acq_rel, acquire) === desired
        @test xs[1] === x2
        @testset for (op, name) in OP_RMW_TABLE
            xs[1] = x1
            @test UnsafeAtomics.modify!(ptr, op, x2, acq_rel) === (x1 => op(x1, x2))
            @test xs[1] === op(x1, x2)

            rmw = getfield(UnsafeAtomics, Symbol(name, :!))
            xs[1] = x1
            @test rmw(ptr, x2, acquire) === x1
            @test xs[1] === op(x1, x2)

            # Test syncscopes.
            if (op == +) || (op == -)
                xs[1] = x1
                @test UnsafeAtomics.modify!(ptr, op, x2, seq_cst, UnsafeAtomics.none) ===
                      (x1 => op(x1, x2))
                @test xs[1] === op(x1, x2)

                xs[1] = x1
                @test UnsafeAtomics.modify!(ptr, op, x2, seq_cst, UnsafeAtomics.singlethread) ===
                      (x1 => op(x1, x2))
                @test xs[1] === op(x1, x2)
            end

            # Check dispatch to LLVM atomic OP instead of CAS loop.
            if (op == +) || (op == -)
                IR = sprint(io->InteractiveUtils.code_llvm(io,
                    UnsafeAtomics.modify!,
                    typeof.((ptr, +, T(1), seq_cst, UnsafeAtomics.singlethread))))
                @test occursin("atomicrmw", IR)
            end
        end
    end
end


@testset "UnsafeAtomicsLLVM" begin
    @testset for T in inttypes
        check_default_ordering(T)
        test_explicit_ordering(T)
    end

    @testset "Zero-sized types" begin
        @test sizeof(Nothing) == 0
        check_default_ordering([nothing, nothing], nothing, nothing)
        test_explicit_ordering([nothing, nothing], nothing, nothing)
    end
end

module TestSyncScopes

using UnsafeAtomics: UnsafeAtomics, SyncScope
using Test

const SYNCSCOPES = [:none, :singlethread]

function check_syncscope(name::Symbol)
    sync = getfield(UnsafeAtomics, name)
    @test sync isa SyncScope
    @test string(sync) == sprint(print, sync) == string(sync)
    @test repr(sync) == "UnsafeAtomics.$name"
end

function test_syncscope()
    @testset for name in SYNCSCOPES
        check_syncscope(name)
    end
end

end  # module

module Bits

export AbstractBits, asbits

abstract type AbstractBits end

function asuint end
function asbits end

for T in [UInt8, UInt16, UInt32, UInt64, UInt128]
    C = :(Base.$(nameof(T)))
    nbits = sizeof(T) * 8
    B = Symbol("Bits$(nbits)")
    @eval begin
        export $B
        primitive type $B <: AbstractBits $nbits end
        asbits(::Type{$T}) = $B
        asuint(::Type{$B}) = $T
        $B(x::$T) = reinterpret($B, x)
        $C(x::$B) = reinterpret($T, x)
    end
end

Base.rand(::Type{B}) where {B<:AbstractBits} = B(rand(asuint(B)))

end  # module

baremodule UnsafeAtomics

abstract type Ordering end
abstract type SyncScope end

function load end
function store! end
function cas! end
function modify! end
function fence end

function add! end
function sub! end
function xchg! end
function and! end
function nand! end
function or! end
function xor! end
function max! end
function min! end

# =>
right(_, x) = x

module Internal

using Base.Sys: WORD_SIZE
using Base: bitcast, llvmcall

using ..UnsafeAtomics: UnsafeAtomics, Ordering, SyncScope, right

include("utils.jl")
include("orderings.jl")
include("syncscopes.jl")
include("core.jl")

end  # module Internal

const unordered = Internal.unordered
const monotonic = Internal.monotonic
const acquire = Internal.acquire
const release = Internal.release
const acq_rel = Internal.acq_rel
const seq_cst = Internal.seq_cst

# Julia names
const acquire_release = acq_rel
const sequentially_consistent = seq_cst

# SyncScope
const none = Internal.none
const singlethread = Internal.singlethread

end  # baremodule UnsafeAtomics

baremodule UnsafeAtomicsLLVM

module Internal

using Core: LLVMPtr
using LLVM
using UnsafeAtomics: UnsafeAtomics, Ordering

include("internal.jl")

end  # module Internal

end  # baremodule UnsafeAtomicsLLVM

# TODO: move this to UnsafeAtomics
julia_ordering_name(::UnsafeAtomics.Internal.LLVMOrdering{name}) where {name} = name
julia_ordering_name(::typeof(UnsafeAtomics.acquire_release)) = :acquire_release
julia_ordering_name(::typeof(UnsafeAtomics.sequentially_consistent)) =
    :sequentially_consistent

julia_syncscope_name(::UnsafeAtomics.Internal.LLVMSyncScope{name}) where {name} = name
julia_syncscope_name(::typeof(UnsafeAtomics.none)) = :system

include("atomics.jl")

@inline UnsafeAtomics.load(ptr::LLVMPtr, order::Ordering, sync::UnsafeAtomics.Internal.SyncScope) =
    atomic_pointerref(ptr, Val{julia_ordering_name(order)}(), Val{julia_syncscope_name(sync)}())

@inline function UnsafeAtomics.store!(ptr::LLVMPtr, x, order::Ordering, sync::UnsafeAtomics.Internal.SyncScope)
    atomic_pointerset(ptr, x, Val{julia_ordering_name(order)}(), Val{julia_syncscope_name(sync)}())
    return
end

mapop(op::OP) where {OP} = op
mapop(::typeof(UnsafeAtomics.right)) = right

@inline UnsafeAtomics.modify!(ptr::LLVMPtr, op::OP, x, order::Ordering, sync::UnsafeAtomics.Internal.SyncScope) where {OP} =
    atomic_pointermodify(ptr, mapop(op), x, Val{julia_ordering_name(order)}(), Val{julia_syncscope_name(sync)}())

@inline UnsafeAtomics.cas!(
    ptr::LLVMPtr,
    expected,
    desired,
    success_order::Ordering,
    failure_order::Ordering,
    sync::UnsafeAtomics.Internal.SyncScope,
) = atomic_pointerreplace(
    ptr,
    expected,
    desired,
    Val{julia_ordering_name(success_order)}(),
    Val{julia_ordering_name(failure_order)}(),
    Val{julia_syncscope_name(sync)}(),
)

module TestOrderings

using UnsafeAtomics: UnsafeAtomics, Ordering
using Test

const ORDERINGS = [:unordered, :monotonic, :acquire, :release, :acq_rel, :seq_cst]

function check_ordering(name::Symbol)
    ord = getfield(UnsafeAtomics, name)
    @test ord isa Ordering
    @test string(ord) == sprint(print, ord) == string(name)
    @test repr(ord) == "UnsafeAtomics.$name"
end

function test_ordering()
    @testset for name in ORDERINGS
        check_ordering(name)
    end
end

function test_aliases()
    @test UnsafeAtomics.acq_rel === UnsafeAtomics.acquire_release
    @test UnsafeAtomics.seq_cst === UnsafeAtomics.sequentially_consistent
end

end  # module

struct LLVMSyncScope{name} <: SyncScope end

const none = LLVMSyncScope{:none}()
const singlethread = LLVMSyncScope{:singlethread}()

const syncscopes = (none, singlethread)
const ConcreteSyncScopes = Union{map(typeof, syncscopes)...}

llvm_syncscope(::LLVMSyncScope{name}) where {name} = name

Base.string(s::LLVMSyncScope) = string("syncscope(\"", llvm_syncscope(s), "\")")
Base.string(s::typeof(none)) = ""

Base.print(io::IO, s::LLVMSyncScope) = print(io, string(s))

Base.show(io::IO, o::ConcreteSyncScopes) = print(io, UnsafeAtomics, '.', llvm_syncscope(o))

module TestCore

using UnsafeAtomics: UnsafeAtomics, monotonic, acquire, release, acq_rel, seq_cst, right
using UnsafeAtomics: none, singlethread
using UnsafeAtomics.Internal: OP_RMW_TABLE, inttypes, floattypes
using Test

using ..Bits

function test_default_ordering()
    @testset for T in inttypes
        test_default_ordering(T)
    end
    @testset for T in floattypes
        test_default_ordering(T)
    end
    @testset for T in (asbits(T) for T in inttypes if T <: Unsigned)
        test_default_ordering(T)
    end
    UnsafeAtomics.fence()
end

rmw_table_for(@nospecialize T) =
    if T <: AbstractFloat
        ((op, rmwop) for (op, rmwop) in OP_RMW_TABLE if op in (+, -))
    elseif T <: AbstractBits
        ((op, rmwop) for (op, rmwop) in OP_RMW_TABLE if op in (right,))
    else
        OP_RMW_TABLE
    end

function test_default_ordering(T::Type)
    xs = T[rand(T), rand(T)]
    x1 = rand(T)
    x2 = rand(T)
    @debug "xs=$(repr(xs)) x1=$(repr(x1)) x2=$(repr(x2))"

    ptr = pointer(xs, 1)
    GC.@preserve xs begin
        @test UnsafeAtomics.load(ptr) === xs[1]
        UnsafeAtomics.store!(ptr, x1)
        @test xs[1] === x1
        desired = (old = x1, success = true)
        @test UnsafeAtomics.cas!(ptr, x1, x2) === (old = x1, success = true)
        @test xs[1] === x2
        @testset for (op, name) in rmw_table_for(T)
            xs[1] = x1
            @test UnsafeAtomics.modify!(ptr, op, x2) === (x1 => op(x1, x2))
            @test xs[1] === op(x1, x2)

            rmw = getfield(UnsafeAtomics, Symbol(name, :!))
            xs[1] = x1
            @test rmw(ptr, x2) === x1
            @test xs[1] === op(x1, x2)
        end
    end
end

function test_explicit_ordering()
    @testset for T in [UInt, Float64]
        test_explicit_ordering(T)
    end
    UnsafeAtomics.fence(monotonic)
    UnsafeAtomics.fence(acquire)
    UnsafeAtomics.fence(release)
    UnsafeAtomics.fence(acq_rel)
    UnsafeAtomics.fence(seq_cst)
end

function test_explicit_ordering(T::Type)
    xs = T[rand(T), rand(T)]
    x1 = rand(T)
    x2 = rand(T)
    @debug "xs=$(repr(xs)) x1=$(repr(x1)) x2=$(repr(x2))"

    ptr = pointer(xs, 1)
    GC.@preserve xs begin

        @test UnsafeAtomics.load(ptr, acquire) === xs[1]
        UnsafeAtomics.store!(ptr, x1, release)
        @test xs[1] === x1
        desired = (old = x1, success = true)
        @test UnsafeAtomics.cas!(ptr, x1, x2, acq_rel, acquire) === desired
        @test xs[1] === x2
        @testset for (op, name) in rmw_table_for(T)
            xs[1] = x1
            @test UnsafeAtomics.modify!(ptr, op, x2, acq_rel) === (x1 => op(x1, x2))
            @test xs[1] === op(x1, x2)

            rmw = getfield(UnsafeAtomics, Symbol(name, :!))
            xs[1] = x1
            @test rmw(ptr, x2, acquire) === x1
            @test xs[1] === op(x1, x2)
        end
    end
end

function test_explicit_syncscope(T::Type)
    xs = T[rand(T), rand(T)]
    x1 = rand(T)
    x2 = rand(T)
    @debug "xs=$(repr(xs)) x1=$(repr(x1)) x2=$(repr(x2))"

    ptr = pointer(xs, 1)
    GC.@preserve xs begin

        @test UnsafeAtomics.load(ptr, acquire, none) === xs[1]
        @test UnsafeAtomics.load(ptr, acquire, singlethread) === xs[1]
        UnsafeAtomics.store!(ptr, x1, release, singlethread)
        @test xs[1] === x1
        desired = (old = x1, success = true)
        @test UnsafeAtomics.cas!(ptr, x1, x2, acq_rel, acquire, singlethread) === desired
        @test xs[1] === x2
        @testset for (op, name) in rmw_table_for(T)
            xs[1] = x1
            @test UnsafeAtomics.modify!(ptr, op, x2, acq_rel, singlethread) === (x1 => op(x1, x2))
            @test xs[1] === op(x1, x2)

            rmw = getfield(UnsafeAtomics, Symbol(name, :!))
            xs[1] = x1
            @test rmw(ptr, x2, acquire, singlethread) === x1
            @test xs[1] === op(x1, x2)
        end
    end
end

function test_explicit_syncscope()
    @testset for T in [UInt, Float64]
        test_explicit_syncscope(T)
    end
    UnsafeAtomics.fence(monotonic, none)
    UnsafeAtomics.fence(acquire, singlethread)
    UnsafeAtomics.fence(release, singlethread)
    UnsafeAtomics.fence(acq_rel, none)
    UnsafeAtomics.fence(seq_cst, none)
end

end  # module
